unit callite_dialog;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ButtonPanel,
  CalendarLite;

type

  { TCalLiteForm }

  TCalLiteForm = class(TForm)
    ButtonPanel1: TButtonPanel;
    procedure FormCreate(Sender: TObject);
  private
    FCalendar: TCalendarLite;
    function GetColors: TCalColors;
    function GetDate: TDate;
    function GetLanguage: TLanguage;
    function GetOptions: TCalOptions;
    function GetStartingDayOfWeek: TDayOfWeek;
    procedure SetColors(const Value: TCalColors);
    procedure SetDate(const Value: TDate);
    procedure SetLanguage(const Value: TLanguage);
    procedure SetOptions(const Value: TCalOptions);
    procedure SetStartingDayOfWeek(const Value: TDayOfWeek);
  public
    function Execute: Boolean;
    property Colors: TCalColors read GetColors write SetColors;
    property Date: TDate read GetDate write SetDate;
    property Language: TLanguage read GetLanguage write SetLanguage;
    property Options: TCalOptions read GetOptions write SetOptions;
    property StartingDayOfWeek: TDayOfWeek read GetStartingDayOfWeek write SetStartingDayOfWeek;
  end;

var
  CalLiteForm: TCalLiteForm;

implementation

{$R *.lfm}

{ TCalLiteForm }

function TCalLiteForm.Execute: Boolean;
begin
  Result := ShowModal = mrOK;
end;

procedure TCalLiteForm.FormCreate(Sender: TObject);
begin
  BorderStyle := bsDialog;
  FCalendar := TCalendarLite.Create(self);
  FCalendar.Parent := self;
  FCalendar.Align := alClient;
  FCalendar.BorderSpacing.Around := 6;
  AutoSize := true;
end;

function TCalLiteForm.GetColors: TCalColors;
begin
  Result := FCalendar.Colors;
end;

function TCalLiteForm.GetDate: TDate;
begin
  Result := FCalendar.Date;
end;

function TCalLiteForm.GetLanguage: TLanguage;
begin
  Result := FCalendar.Languages;
end;

function TCalLiteForm.GetOptions: TCalOptions;
begin
  Result := FCalendar.Options;
end;

function TCalLiteForm.GetStartingDayOfWeek: TDayOfWeeK;
begin
  Result := FCalendar.StartingDayOfWeek;
end;

procedure TCalLiteForm.SetColors(const Value: TCalColors);
begin
  FCalendar.Colors := Value;
end;

procedure TCalLiteForm.SetDate(const Value: TDate);
begin
  FCalendar.Date := Value;
end;

procedure TCalLiteForm.SetLanguage(const Value: TLanguage);
begin
  FCalendar.Languages := Value;
  case Value of
    lgEnglish:
      begin
        Caption := 'Calendar';
        ButtonPanel1.CancelButton.Caption := 'Cancel';
      end;
    lgGerman:
      begin
        Caption := 'Kalender';
        ButtonPanel1.CancelButton.Caption := 'Abbrechen';
      end;
  end;
end;

procedure TCalLiteForm.SetOptions(const Value: TCalOptions);
begin
  FCalendar.Options := Value;
end;

procedure TCalLiteForm.SetStartingDayOfWeek(const Value: TDayOfWeek);
begin
  FCalendar.StartingDayOfWeek := Value;
end;

end.

